pipeline {
    agent any
    stages {
        stage("Build") {
            environment{
                DB_HOST = 'mysql-jenkins'
                DB_USERNAME = 'root'
                DB_DATABASE = 'jenkins' 
                DB_PASSWORD = 'jenkins'
            }
            steps {
                sh 'php --version'
                sh 'composer install'
                sh 'composer --version'
                sh 'cp .env.example .env'
                sh 'echo DB_HOST=${DB_HOST} >> .env'
                sh 'echo DB_USERNAME=${DB_USERNAME} >> .env'
                sh 'echo DB_DATABASE=${DB_DATABASE} >> .env'
                sh 'echo DB_PASSWORD=${DB_PASSWORD} >> .env'
                sh 'php artisan key:generate'
                sh 'cp .env .env.testing'
                sh 'php artisan migrate'
            }
        }
        stage("Unit test") {
            steps {
                sh 'php artisan test'
            }
        }
        stage("Code coverage") {
            steps {
                sh "vendor/bin/phpunit --coverage-html 'reports/coverage'"
            }
        }
        stage("Static code analysis larastan") {
            steps {
                sh "vendor/bin/phpstan analyse --memory-limit=2G"
            }
        }
        stage("Static code analysis phpcs") {
            steps {
                sh "vendor/bin/phpcs"
            }
        }
           stage("Docker build") {
            environment{
                DOCKER_USERNAME = 'piyapat.s@outlook.com'
                DOCKER_PASSWORD = 'Pokemonruby5-'
                DOCKER_IMAGENAME = 'best9991/best/test'
            }   
            steps {
                sh "docker build -t ${DOCKER_IMAGENAME} ."
            }
        }
        stage("Docker push") {
            steps {
                sh "docker login --username ${DOCKER_USERNAME} --password ${DOCKER_PASSWORD}"
                sh "docker push ${DOCKER_IMAGENAME}"
            }
        }
        stage("Deploy to staging") {
            steps {
                sh "docker run -d --rm -p 80:80 --name laravel8cd ${DOCKER_IMAGENAME}"
            }
        }
        stage("Acceptance test curl") {
            steps {
                sleep 20
                sh "chmod +x acceptance_test.sh && ./acceptance_test.sh"
            }
        }
        stage("Acceptance test codeception") {
            steps {
                sh "ls"
            }
            post {
                always {
                    sh "docker stop laravel8cd"
                }
            }
        }
    }
}
    